from sklearn import neighbors
from sklearn import svm
from sklearn import neural_network
from matplotlib import pyplot
from matplotlib import colors
from collections import Counter
import numpy

# Format: [x1, x2, y]
X = numpy.array([[1, 2], [3, 5], [2, 4], [4, 5], [3, 3], [5, 1], [4, 1]])
y = numpy.array([ 0,      0,      0,      1,      1,      0,      1])

# for i in range(6):  # Vorsicht: exponentielles Wachstum!
#    X = numpy.append(X, X + 0.2 * numpy.random.randn(len(X), 2), axis = 0)
#    y = numpy.append(y, y)

u, v = numpy.meshgrid(numpy.linspace(0.0, 6.0, 200),
                      numpy.linspace(0.0, 6.0, 200))
uv = numpy.c_[u.ravel(), v.ravel()]
colors1 = colors.ListedColormap(['#0000FF', '#FF0000'])
colors2 = colors.ListedColormap(['#9090FF', '#FF6060'])


nn = neighbors.NearestNeighbors(n_neighbors=1).fit(X)
distances, indices = nn.kneighbors(numpy.c_[u.ravel(), v.ravel()])
z = y[indices.reshape(u.shape)]


# nn = neighbors.NearestNeighbors(n_neighbors=3).fit(X)
# distances, indices = nn.kneighbors(uv)
# z = numpy.zeros(len(indices))
# for i in range(len(indices)):
#    c = Counter(y[indices[i, :]])
#    z[i] = c.most_common(1)[0][0]
# z = z.reshape(u.shape)


# svc = svm.LinearSVC(dual="auto")
# svc.fit(X, y)
# z = svc.predict(uv)
# z = z.reshape(u.shape)


# svc = svm.SVC(gamma='auto') # gamma='auto' nur, damit es wie im Video aussieht, denn der Default-Wert wurde zwischenzeitlich geändert
# svc.fit(X, y)
# z = svc.predict(uv)
# z = z.reshape(u.shape)


# neur = neural_network.MLPClassifier(hidden_layer_sizes=(8, 8), max_iter=1000)
# z = neur.fit(X + numpy.random.randn(len(X), 2), y)
# z = neur.predict(uv)
# z = z.reshape(u.shape)
# print([coef.shape for coef in neur.coefs_])
# print(neur.coefs_)
# print([interc.shape for interc in neur.intercepts_])
# print(neur.intercepts_)

pyplot.contourf(u, v, z, cmap = colors2)
pyplot.scatter(X[:, 0], X[:, 1], 150, y, cmap = colors1)
pyplot.axis('equal')
pyplot.show()